addDx$age_at_first_visit <- patients[match(addDx$cfar_pid, patients$cfar_pid, nomatch=NA),'age_at_first_visit']

# ----------------------------- #
#  Metabolic disorder outcomes  #
# ----------------------------- #
# Include:
# 1) Diabetes, diagnosed or HbA1c > 6.5%
# 2) Dyslipidemia - LDL > 160 OR or AND??? total cholesterol > 200
# 3) NALFD/NASH
# 4) Obesity (BMI >= 30)



# --------------------- #
#    Type 2 diabetes    #
# --------------------- #
addDx <- diagnosis_function(d = addDx,
                            condNme = addDx$na_accord_diagnosis_label == 'Diabetes Type 2',
                            dxNme = 'dm_dx_overall',
                            minAgeNme = 'min_age_dm_dx',
                            ageVar = 'age_at_dx_onset_2018_qtr4')


# --------------------- #
#     Dyslipidemia      #
# --------------------- #
addDx <- diagnosis_function(d = addDx,
                            condNme = addDx$na_accord_diagnosis_label == 'Dyslipidemia',
                            dxNme = 'dyslipidemia_dx_overall',
                            minAgeNme = 'min_age_dyslipidemia_dx',
                            ageVar = 'age_at_dx_onset_2018_qtr4')





#condNALFD <- grepl('NAFLD',cvdDx$na_accord_diagnosis_label)

#addDx$metabolic_outcome_partial <- as.numeric(condDM | condDysl)
#addDx$metabolic_outcome_partial_age <- NA
#addDx$metabolic_outcome_partial_age[addDx$metabolic_outcome_partial == 1] <- addDx$age_at_dx_onset_2018_qtr4[addDx$metabolic_outcome_partial == 1]

#addDx$metabolic_outcome_partial_overall <- NA
#split(addDx$metabolic_outcome_partial_overall, addDx$cfar_pid) <- lapply(split(addDx$metabolic_outcome_partial, addDx$cfar_pid),
#                                                                         FUN=function(y){
#                                                                            as.numeric(any(y > 0))
#                                                                         })
#addDx$metabolic_outcome_partial_age_overall <- NA
#split(addDx$metabolic_outcome_partial_age_overall, addDx$cfar_pid) <- lapply(split(addDx$metabolic_outcome_partial_age, addDx$cfar_pid),
#                                                                         FUN=function(y){
#                                                                            if(any(!is.na(y))){
#                                                                               tmp <- min(y, na.rm=TRUE)
#                                                                            } else {
#                                                                               tmp <- NA
#                                                                            }
#                                                                            return(tmp)
#                                                                            })
#cvdDx$nafld_outcome_partial <- as.numeric(condNALFD)
#cvdDx$nafld_outcome_partial_age <- NA
#cvdDx$nafld_outcome_partial_age[condNALFD] <- cvdDx$age_at_dx_onset_2018_qtr4[condNALFD]
#cvdDx$nafld_outcome_partial_overall <- NA
#split(cvdDx$nafld_outcome_partial_overall, cvdDx$cfar_pid) <- lapply(split(cvdDx$nafld_outcome_partial, cvdDx$cfar_pid),
#                                                                 FUN=function(y){
#                                                                    as.numeric(any(y > 0))
#                                                                 })

#cvdDx$nafld_outcome_partial_age_overall <- NA
#split(cvdDx$nafld_outcome_partial_age_overall, cvdDx$cfar_pid) <- lapply(split(cvdDx$nafld_outcome_partial_age, cvdDx$cfar_pid),
#                                                                     FUN=function(y){
#                                                                        if(any(!is.na(y))){
#                                                                           tmp <- min(y, na.rm=TRUE)
#                                                                        } else {
#                                                                           tmp <- NA
#                                                                        }
#                                                                        return(tmp)
#                                                                     })
