# labsD data management
labsD$age_at_first_visit <- patients[match(labsD$cfar_pid, patients$cfar_pid, nomatch=NA),'age_at_first_visit']
labsD$age_at_censor <- patients[match(labsD$cfar_pid, patients$cfar_pid, nomatch=NA),'age_at_censor']

condAfterCensor <- !is.na(labsD$age_at_result_date) & labsD$age_at_result_date > labsD$age_at_censor
labsD <- labsD[!condAfterCensor,]

# ---------------------------- #
#        Diabetes labs         #
# ---------------------------- #
condDMtest <- labsD$testname == 'HEMOGLOBIN A1C'
dmD <- labsD[condDMtest,]
dmD$hba1cGT <- as.numeric(dmD$result_numeric > 6.5)


dmD <- diagnosis_function(d = dmD,
                          condNme = dmD$result_numeric > 6.5,
                          dxNme = 'hba1cGT_overall',
                          minAgeNme = 'min_age_hba1c_dm',
                          ageVar = 'age_at_result_date')



#dmD$hba1cGT_overall <- NA
#split(dmD$hba1cGT_overall, dmD$cfar_pid) <- lapply(split(dmD$hba1cGT, dmD$cfar_pid), FUN=function(y){
#                                               as.numeric(any(!is.na(y) & y > 0))
#                                            })

## Finding minimum age of DM Type 2 diagnosis:
#dmD$min_age_hba1c_dm <- NA
#split(dmD$min_age_hba1c_dm, dmD$cfar_pid) <- lapply(split(dmD[,c('age_at_result_date','hba1cGT_overall')], dmD$cfar_pid),
#                                                FUN=function(y){
#                                                   if(any(y[['hba1cGT_overall']] == 1)){
#                                                      tmp <- min(y[which(y[['hba1cGT_overall']] == 1),'age_at_result_date'],na.rm=TRUE)
#                                                   } else {
#                                                      tmp <- NA
#                                                   }
#                                                   return(tmp)
#                                             })

# Is HbA1c at the age of first visit DM prior to enrollment causing this person to be excluded?
dmD$dm_hba1c_prior_to_first_visit <- as.numeric(dmD$min_age_hba1c_dm <= dmD$age_at_first_visit + 30/365.25)


# ---------------------------- #
#      Dyslipidemia labs       #
# ---------------------------- #
condLDL <- labsD$testname == 'LDL CHOLESTEROL'
ldlD <- labsD[condLDL,]
ldlD$ldlGT <- as.numeric(ldlD$result_numeric > 160)


ldlD <- diagnosis_function(d = ldlD,
                          condNme = ldlD$result_numeric > 160,
                          dxNme = 'ldlGT_overall',
                          minAgeNme = 'min_age_ldl_gt',
                          ageVar = 'age_at_result_date')

#ldlD$ldlGT_overall <- NA
#split(ldlD$ldlGT_overall, ldlD$cfar_pid) <- lapply(split(ldlD$ldlGT, ldlD$cfar_pid), FUN=function(y){
#                                               as.numeric(any(!is.na(y) & y > 0))
#                                            })

#ldlD$min_age_ldl_gt <- NA
#split(ldlD$min_age_ldl_gt, ldlD$cfar_pid) <- lapply(split(ldlD[,c('age_at_result_date','ldlGT_overall')], ldlD$cfar_pid),
#                                                FUN=function(y){
#                                                  if(any(y[['ldlGT_overall']] == 1)){
#                                                     tmp <- min(y[which(y[['ldlGT_overall']] == 1),'age_at_result_date'], na.rm=TRUE)
#                                                  } else {
#                                                     tmp <- NA
#                                                  }
#                                                  return(tmp)
#                                             })

ldlD$ldlGT_prior_to_first_visit <- as.numeric(ldlD$min_age_ldl_gt <= ldlD$age_at_first_visit + 30/365.25)


# Total cholesterol:
condChol <- labsD$testname == 'TOTAL CHOLESTEROL'
cholD <- labsD[condChol,]
cholD$tcGT <- as.numeric(cholD$result_numeric > 200)


cholD <- diagnosis_function(d = cholD,
                          condNme = cholD$result_numeric > 200,
                          dxNme = 'tcGT_overall',
                          minAgeNme = 'min_age_tc_gt',
                          ageVar = 'age_at_result_date')

#cholD$tcGT_overall <- NA
#split(cholD$tcGT_overall, cholD$cfar_pid) <- lapply(split(cholD$tcGT, cholD$cfar_pid), FUN=function(y){
#                                               as.numeric(any(!is.na(y) & y > 0))
#                                            })

#cholD$min_age_tc_gt <- NA
#split(cholD$min_age_tc_gt, cholD$cfar_pid) <- lapply(split(cholD[,c('age_at_result_date','tcGT_overall')], cholD$cfar_pid),
#                                                FUN=function(y){
#                                                  if(any(y[['tcGT_overall']] == 1)){
#                                                     tmp <- min(y[which(y[['tcGT_overall']] == 1),'age_at_result_date'], na.rm=TRUE)
#                                                  } else {
#                                                     tmp <- NA
#                                                  }
#                                                  return(tmp)
#                                             })

cholD$tcGT_prior_to_first_visit <- as.numeric(cholD$min_age_tc_gt <= cholD$age_at_first_visit + 30/365.25)


# Determining whether dyslipidemia was diagnosed via labs:
labsD$ldlGT_overall <- ldlD[match(labsD$cfar_pid, ldlD$cfar_pid, nomatch=NA),'ldlGT_overall']
labsD$min_age_ldl_gt <- ldlD[match(labsD$cfar_pid, ldlD$cfar_pid, nomatch=NA),'min_age_ldl_gt']

labsD$tcGT_overall <- cholD[match(labsD$cfar_pid, cholD$cfar_pid, nomatch=NA),'tcGT_overall']
labsD$min_age_tc_gt <- cholD[match(labsD$cfar_pid, cholD$cfar_pid, nomatch=NA),'min_age_tc_gt']

condDysLab <- (!is.na(labsD$ldlGT_overall) & labsD$ldlGT_overall == 1) |
              (!is.na(labsD$tcGT_overall) & labsD$tcGT_overall == 1)
labsD$dyslipidemia_labs <- as.numeric(condDysLab)

