# Data management for rawDx data:
rawDx$age_at_first_visit <- patients[match(rawDx$cfar_pid, patients$cfar_pid, nomatch=NA),'age_at_first_visit']
rawDx$age_at_censor <- patients[match(rawDx$cfar_pid, patients$cfar_pid, nomatch=NA),'age_at_censor']

condAfterCensor <- !is.na(rawDx$age_at_onset) & rawDx$age_at_onset > rawDx$age_at_censor
rawDx <- rawDx[!condAfterCensor,]

# Since it seems that all diagnoses in these data are eligible for the thromobosis outcome -- DVT and PE -- then the indicator should just be 1 for all:
rawDx$thrombosis_event_overall <- 1

rawDx$thrombosis_event_overall_age <- NA
split(rawDx$thrombosis_event_overall_age, rawDx$cfar_pid) <- lapply(split(rawDx$age_at_onset, rawDx$cfar_pid), FUN=function(y){
                                                                min(y, na.rm=TRUE)
                                                             })

rawDx$thrombosis_event_prior_to_first_visit <- as.numeric(rawDx$thrombosis_event_overall_age <= rawDx$age_at_first_visit + 30/365.25)
